//_/////////////////////////////////////////////////////////////////////////////
//   MB Hopeless Productions proudly presents competely freeware:
//_
//_Name: TMBMenu ver. 98.04.01 - TMainMenu + recent files list
//_
//_Category: API
//_
//_Properties:   
//_P procedure ShowRecent; - to show recent files list
//_P procedure AddRecentFile(FileName:String); - to add a file to the list
//_
//_P property ListCount:Integer; - for changing No. of items on the list 
//_                               (not fully implemented now)
//_P property OnRecentClick:TNotifyEvent; - recent Item click. You may use it
//_                                to open the file :
//_                                MyOpenFileProc(TMenuItem(Sender).Caption);
//_
//_Contact: mbisz@friko2.onet.pl
//_/////////////////////////////////////////////////////////////////////////////
unit MBMenu;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus,registry;

type
  TMBMenu = class(TMainMenu)
  private
    { Private declarations }
  protected
    { Protected declarations }
    FReg:TRegIniFile;
    FRegKey:String;
    FOnRecentClick:TNotifyEvent;
    FListCount:integer;
    procedure RIClick(Sender: TObject);
  public
    { Public declarations }
    constructor Create(AOwner:TComponent);override;
    destructor Destroy;override;
    function GetAppName:String;
    procedure AddRMenuItem(Item:String);
    procedure ShowRecent;
    procedure AddRecentFile(FileName:String);
    procedure UstListCount(nListCount:integer);

  published
    { Published declarations }
    property ListCount:Integer read FListCount write UstListCount;
    property OnRecentClick:TNotifyEvent read FOnRecentClick write FOnRecentClick;
  end;

procedure Register;

implementation

constructor TMBMenu.Create(AOWner:TComponent);
begin
inherited Create(AOwner);
FListCount:=5;
FReg:=TRegIniFile.Create('');
FRegKey:='Software\MB\'+GetAppName()+'\Recent Files';
FReg.RootKey:=HKEY_CURRENT_USER;
end;

destructor TMBMenu.Destroy;
begin
FReg.Free;
inherited Destroy;
end;

procedure TMBMenu.UstListCount(nListCount:integer);
begin
if (not (FReg.KeyExists(FRegKey))) then
   FListCount:=nListCount
else
   begin
   //WORK - extending ListCount
   end;
end;


procedure TMBMenu.ShowRecent;
var
  s:String;
  i,j:integer;
begin
if FReg.KeyExists(FRegKey) then
   begin
   j:=FReg.ReadInteger(FRegKey,'No',-1);
   FListCount:=FReg.ReadInteger(FRegKey,'Cr',-1);
   i:=FListCount;
   while (i<=j) do
      begin
      s:=FReg.ReadString(FRegKey,'File'+IntToStr(i),'');
      if (s<>'') then
         begin
         AddRMenuItem(s);
         i:=i+1;
         if (i>j) then i:=1;
         if (i=FListCount) then i:=j+1;
         end
      else
         i:=j+1;
      end;
   AddRMenuItem('-'); //separator
   end
else
   begin
   FReg.WriteInteger(FRegKey,'No',FListCount);
   FReg.WriteInteger(FRegKey,'Cr',1);
   for i:=1 to FListCount do
      begin
      FReg.WriteString(FRegKey,'File'+IntToStr(i),'');
      end;
   end;
end;


procedure TMBMenu.AddRMenuItem(Item:String);
var
   nn:TMenuItem;
   pr:TMenuItem;
begin
pr:=Self.Items[0]; // first item as default
nn:=TMenuItem.Create(pr);
nn.Caption:=Item;
nn.OnClick:=RIClick;
pr.Add(nn);
end;

procedure TMBMenu.AddRecentFile(FileName:String);
var
  Cr,i:integer;
  bSave:boolean;
begin
Cr:=FReg.ReadInteger(FRegKey,'Cr',-1);
FListCount:=FReg.ReadInteger(FRegKey,'No',-1);
Cr:=Cr-1;
if (Cr<1) then Cr:=FlistCount;
bSave:=true;
for i:=1 to FListCount do
  if (FReg.ReadString(FRegKey,'File'+IntToStr(i),'')=FileName) then bSave:=false;
if (bSave) then
begin
if (Cr>0) then
   begin
   FReg.WriteString(FRegKey,'File'+IntToStr(Cr),FileName);
   FReg.WriteInteger(FRegKey,'Cr',Cr);
   end;
Self.AddRMenuItem(FileName);
end;
end;

function TMBMenu.GetAppName:String;
begin 
Result:=ExtractFileName(Application.ExeName);
end;

procedure TMBMenu.RIClick(Sender: TObject);
begin
if (Assigned(FOnRecentClick)) then
   FOnRecentClick(Sender);
end;


procedure Register;
begin
  RegisterComponents('MB', [TMBMenu]);
end;

end.
